package edu.washington.cs.gui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import edu.washington.cs.MeetUpManager;
import edu.washington.cs.R;
import edu.washington.cs.TTSManager;
import edu.washington.cs.core.AUIActivity;

/**
 * Direction screen. 
 * @author Nara
 *
 */
public class DirectionActivity extends AUIActivity{
	
	private final String TAG = "DirectionActivity";
	protected static int TRAVEL_CODE = 99;
	protected final String title = "Directions";

	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(edu.washington.cs.R.layout.direction_menu);
		
		((ImageView) findViewById(R.id.interaction_overlay)).setOnTouchListener(this);
		rootLayout = (ViewGroup) findViewById(edu.washington.cs.R.id.main);
    }
    
	@Override
	public void onResume() {
		super.onResume();
		
		if(TTSManager.getInstance() != null) {
			TTSManager.getInstance().flush(TTSManager.MESSAGE_PRIORITY_LOW);
			TTSManager.getInstance().speak(getResources().getString(R.string.direction_title), TTSManager.MESSAGE_PRIORITY_IMPORTANT);
		}
	}
    
    @Override
    public void ttsCreated() {
    	if(!GUIState.hasVisitedDirection() && tts != null) {
			tts.speak(getResources().getString(R.string.direction_directions), TTSManager.MESSAGE_PRIORITY_LOW);
    		GUIState.visitDirection();
    	}
    }

	@Override
	public void onClick(View v) {
		if(v instanceof Button) {
			if(((Button) v).equals((Button) findViewById(R.id.button1))) {
				//CURRENT STEP
				tts.speak(MeetUpManager.getInstance().getCurrentStep(), TTSManager.MESSAGE_PRIORITY_NORMAL);
				
			} else if(((Button) v).equals((Button) findViewById(R.id.button2))) { 
				//NEXT STEP: SETS CURRENT STEP TO THE VERY NEXT STEP.
				tts.speak(MeetUpManager.getInstance().getNextStep(), TTSManager.MESSAGE_PRIORITY_NORMAL);
				
			} else if(((Button) v).equals((Button) findViewById(R.id.button3))) {
				//Travel Mode : Walking, driving, bicycling
				if(MeetUpManager.getInstance().areWeInAMeetUp()) {
					Intent intent = new Intent(this, edu.washington.cs.gui.TravelModeActivity.class);								
				    startActivityForResult(intent, TRAVEL_CODE);
				} else {
					tts.speak("You are not currently in Meet Up", TTSManager.MESSAGE_PRIORITY_NORMAL);
				}
				
			} else if(((Button) v).equals((Button) findViewById(R.id.button4))) {
				//ALL STEPS
				tts.speak(MeetUpManager.getInstance().getRouteSummary(), TTSManager.MESSAGE_PRIORITY_NORMAL);								
			} else {
				Log.e(TAG, "ERROR onClick Unknown View clicked");
			}		
		}		
	}

	@Override
	public void onDoubleClick(View v) {}
	
	@Override
	public void onMove(View v) {}
}
